hdu 1024 Max Sum Plus Plus (最大M段子段和)

原题链接:http://acm.hdu.edu.cn/showproblem.php?pid=1024

Max Sum Plus Plus

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 34756    Accepted Submission(s): 12414

Problem Description
Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

Given a consecutive number sequence S 1, S 2, S 3, S 4 ... S x, ... S n (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ S x ≤ 32767). We define a function sum(i, j) = S i + ... + S j (1 ≤ i ≤ j ≤ n).

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i 1, j 1) + sum(i 2, j 2) + sum(i 3, j 3) + ... + sum(i m, j m) maximal (i x ≤ i y ≤ j x or i x ≤ j y ≤ j x is not allowed).

But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(i x, j x)(1 ≤ x ≤ m) instead. ^_^
 

Input
Each test case will begin with two integers m and n, followed by n integers S 1, S 2, S 3 ... S n.
Process to the end of file.

Output
Output the maximal summation described above in one line.

Sample Input
 
  
1 3 1 2 3 2 6 -1 4 -2 3 -2 3

Sample Output
 
  
6 8
Hint
Huge input, scanf and dynamic programming is recommended.

题目大意:

输出一段序列,并且让你分成m段,求分成m段后的最大值

思路:

用dp[i][j]来表示前j个数分成i段的最大值,那么其状态转移方程如下

dp[i][j] = max(dp[i][j-1] + a[j], max(dp[i-1][k]) + a[j] ) 

其中,max(dp[i-1][k]) 表示 用 k (0 < k < j)个元素 去分成i-1组的最大值.这样的话 a[j] 就是单独的自己为一组

但是 根据题目,n的值最多高达100W,上面的想法无论从时间还是空间上来看都是无法满足条件的,所以要进行时间和空间上的优化。


我们可以用一个max数组来保存max(dp[i-1][k]),在计算dp[i][j] 时更新前j-1个的最大值,这样就减少了一次循环去查找dp[i-1][k] 的最大值。

同时,我们也可以用一维的dp来表示dp[i][j]

for(int i = 1;i <= x;i ++)
        {
            mmax = -INF;
            for(int j = i;j<=n;j++)
            {
                ///dp[j]表示J个分i组的最大值
                ///说明Max 的意思是 J - 1 分 i - 1 组的最大值
                ///mmax表示分i组中的最大值
                dp[j] = max(dp[j - 1],Max[j - 1]) + a[j];
                Max[j - 1] = mmax;
                mmax = max(mmax,dp[j]);
            }
        }

因为我们都是从j = i 开始,上个状态的j以后的值我们用不到,所以可以用这种办法去减少空间不足的问题


通过代码

#include<bits/stdc++.h>

using namespace std;

int a[100010];
int dp[100010],Max[100010];

const int INF = (1 <<31) -1;

int main()
{
    int x,n;

    while(scanf("%d %d",&x,&n) != EOF)
    {
        for(int i = 1;i <= n;i ++)
        {
            scanf("%d",&a[i]);
        }

        memset(dp,0,sizeof(dp));
        memset(Max,0,sizeof(Max));

        int mmax;

        for(int i = 1;i <= x;i ++)
        {
            mmax = -INF;
            for(int j = i;j<=n;j++)
            {
                ///dp[j]表示J个分i组的最大值
                ///说明Max 的意思是 J - 1 分 i - 1 组的最大值
                ///mmax表示分i组中的最大值
                dp[j] = max(dp[j - 1],Max[j - 1]) + a[j];

                Max[j - 1] = mmax;

                mmax = max(mmax,dp[j]);
            }

        }
        cout<<mmax<<endl;
    }

    return 0;
}

 
  

猜你喜欢

转载自blog.csdn.net/ii0789789789/article/details/80258988